import pygame
from pygame.locals import *

import resource
import display
from helper import *


def show_story():
	intro_text = [
		["                              ", "                        "],
		["Long ago, in ages forgotten...",
		"    ",
		"War and Strife, for Years untold, had gripped the World;",
		"the Reaper's fearsome Gaze ranged far abroad",
		"a Shadow cast long over all the lands.",
		"         ",
		"The Tide of Blood to quell, a Hero rose",
		"with Wisdom great and Might beyond All Peers,",
		"by Power thus the Hounds of War were tamed",
		"Tranquility to grace the land once more.",
		"            "],
		
		["Now to this Man, a handsome youthful Mage,",
		"in Gratitude the People came for naught",
		"for Solitude was his one True desire",
		"               ",
		"And so all Wealth and Fame were thus declined",
		"as sudden his Appearance so also his Departure.",
		"               "],
		
		["But Fame cannot be quit with ease,",
		"nor Deed forgotten soon,",
		"and over Years, his home was found once more.",
		"                  ",
		"A village grew in lands around",
		"young Children there, of History unheeding",
		"invade his land, disturbing his Peace",
		"until his Patience had worn away.",
		"                        "],
		
		["            ", "And thus, we begin...", "                            "]]
	
	if NOINTRO or DEBUG:
		return

	resource.play('BreizhCoast.mp3')
	
	shade = resource.get_image('ShadeBar')
	f = resource.get_font('Aquiline', 32)
	screen = pygame.display.get_surface()
	prev_lines = pygame.Surface((1024,768), SRCALPHA, screen)
	
	clock = pygame.time.Clock()
	page = 0
	
	while page < len(intro_text):
		line = 0
		y_pos = 0
		screen.fill(pygame.Color('black'))
		prev_lines.fill(pygame.Color(0,0,0,0))
		
		while line < len(intro_text[page]):
			reveal = 0
			text = f.render(intro_text[page][line], True, pygame.Color('white'))
			bar = shade.subsurface(pygame.Rect(0, 0, text.get_width(), text.get_height()))
			while reveal < text.get_width():
				screen.fill(pygame.Color(0,0,0))
				screen.blit(text, (100, y_pos))
				screen.blit(bar, (100 + reveal, y_pos))
				screen.blit(prev_lines, (0, 0))
				reveal += 3
				
				pygame.display.flip()
				clock.tick(60)
			
			prev_lines.blit(text, (100, y_pos))
			y_pos += (text.get_height() * 0.6)
			line += 1
		page += 1
	
	



