import pygame
from pygame.locals import *

import resource
import display
import status
from helper import *

class Conversation:
	[L1, Loss, L2, L3, L4, L5, Dragon, L6, Ending] = range(9)

dialogues = [
	[('Gerald', "These children--! I can't take this anymore!"),
	('MrP', "Whaaaaat. Time to end it all?"),
	('Gerald', "No, you fool. I desire merely a modicum of peace and quiet!"),
	('MrP', "So yer gonna yell about it? I 'unno if you thought this plan through, buddy."),
	('Gerald', 'Perhaps I ought post more "Trespassers Will Be Polymorphed" signs.'),
	('MrP', "The first twenty-four didn't work so great. 'sides, you haven't actually poly'd any of the flea-ridden brats."),
	('MrP', "They prolly think yer a push-over. Mebbe they're right?"),
	('Gerald', "I am Gerald the Greenish-Blue! Greatest wizard of this age!"),
	('MrP', "Yah, an' when was the last time y'cast any magic?"),
	('Gerald', "..."),
	('Gerald', "Well, I'm retired."),
	('MrP', "Yer a geezer, y'mean. If you'd just start lobbin' fireballs like the good 'ol days those brats'd clear out right quick."),
	('Gerald', "I fear you may be right."),
	('MrP', "Wouldn't be the first time, y'know. Lemme guess, you're feeling kinda rusty?"),
	('Gerald', "Alas. It has been decades."),
	('MrP', "Eh, no worries. Mr. P is here to help. Y'don't keep me around for my pretty face, y'know!"),
	('Gerald', "Yes. I know."),
	('MrP', "Okay, more o' those brats are headin' this way. Let's start easy-like, get y'back in the flow."),
	('MrP', "I'm sure you can remember how t'summon a simple monster--a stupid jelly, or whatev'."),
	('Gerald', "Of course. Press space to select what to summon, then click on the lawn tile to bring it in."),
	('MrP', "Yep, though keep in mind ya can only summon on the grass, not the dirt or whatev'."),
	('MrP', "Well, why don't y'call a few jellies to chase the brats off, somethin' simple to start."),
	('Gerald', "I am concerned, though. I do not wish to injure the children."),
	('MrP', "Eh, the runts're sturdier than they look. Once they take a few wallops from the jellies, they'll run home to mommy. Perfectly safe!"),
	('Gerald', "True enough, I suppose."),
	('MrP', "Crap! Here they come!")],
	
	[('Gerald', "Blast it! Oh, my garden!"),
	('MrP', "Wheeew. Y'really are rusty, ain't ya?"),
	('Gerald', "Silence, impudent bird!"),
	('MrP', "A'ight, a'ight, let's try again. Sheesh, cranky."),
	('MrP', "Heads up, here comes another batch!")],
	
	[('MrP', "Well, fat lot o' good that did. They're headin' back, and they got friends this time!"),
	('MrP', "Ya may need to slow 'em down a bit to handle that many... why not summon some traps or barriers?"),
	('Gerald', "A fine plan, and simple enough. I can summon those just as I would the jellies."),
	('MrP', "Yeah, but dun forget they can get around or over the obstacles, so don't count on 'em too much."),
	('MrP', "And since ya prolly forgot, after a trap goes off y'need to right-click on it to reset it. 'course, they do disappear after a few uses."),
	('Gerald', "I beg your pardon. I may be old, but I am not yet senile."),
	('MrP', "Then how come yer socks never match?"),
	('Gerald', "That is, ah, a matter of fashion. One must cultivate the proper image as an eccentric wizard."),
	('MrP', "Yahuh. I'm sure.")],
	
	[('MrP', "Oi, here comes another set."),
	('MrP', "Crap, and this time some of 'em have slingshots! Who let the little runts have those things anyways? Geeez."),
	('Gerald', "Hmmm, clever. Perhaps I shall have to try summoning something more... formidable."),
	('MrP', "Now yer gettin' into it! Rock on, old man.")],

	[('MrP', "Here we go again. Stubborn, ain't they?"),
	('MrP', "Looks like they're bringin' their mutts with 'em this time. Ya sure you got enough juice to handle this?"),
	('Gerald', "My 'juice' is quite adequate, thank you."),
	('MrP', "....yeah, I dun need to know about that, thanks."),
	('Gerald', "..."),
	('MrP', "Still, ya might need some extra mana to keep up with 'em this time. Any ideas?"),
	('Gerald', "Hmm. If I am able to lure them into stepping upon a mana glyph, I may replenish my mana reserves with greater haste."),
	('MrP', "Sounds like a plan!")],
	
	[('MrP', "Woooo, they're really sendin' in the hounds this time. Could be bad."),
	('Gerald', "The dogs do not trigger the pit traps, and their speed will overwhelm most monsters."),
	('Gerald', "Perhaps a stronger creature would be of utility... but what?"),
	('MrP', "How 'bout a Greater Summoning? Invoke the Chaos Wyrm!"),
	('Gerald', "Yes... Yes, indeed. It has been a very long time since I have performed such a feat, however, and the mana draw is prodigious indeed."),
	('MrP', "Looks like a group o' kids is in front... think you can throw down enough mana glyphs to get a Greater Summoning ready before the dogs get here?"),
	('Gerald', "I fear I may have no choice. I will need one thousand points of mana; great, but not impossible."),
	('MrP', "A'ight, you do that.")],

	[('Gerald', "O Great Unending One, Thou who twist space itself to meet Thy pleasure, slumbering among the foundations of the world--hear my call! Awaken and bring forth Thy power, bound to mine, that all who oppose us shall bend to our will! Arise... Chaos Wyrm!"),
	('MrP', "Was that... really necessary?"),
	('Heighway', "Not in the slightest, though it was flattering."),
	('Heighway', "Asking politely would have sufficed, you know."),
	('Gerald', "Oh, what is a gratuitously overwrought incantation between friends? Grant an old wizard have his small pleasures."),
	('Heighway', "As you like it.")],

	[('MrP', "Geeeeez they don't give up. Here comes another batch, an' this time there's a whole lotta them."),
	('Gerald', "Splendid, I shall relish the challenge. What are children before the greatest wizard of the age?"),
	('MrP', "You tell 'em!")],
			
	[('MrP', "'k, this time it looks like we got... huh?"),
	('MrP', "...nothin'?"),
	('Gerald', "Ah. That was it?"),
	('MrP', "Think so! Sweet!"),
	('Gerald', "I confess I'm almost disappointed. I've not had that much fun in many a year."),
	('MrP', 'Eh? What about yer "peace and quiet"?'),
	('Gerald', "I am considering that... perhaps... quiet solitude is a trifle overrated. Sounds rather dull, in point of fact."),
	('MrP', "Oh, whatev'. Crazy old geezer. So now whatcha gonna do?"),
	('Gerald', "Hmm, well."),
	('Gerald', "...perhaps I could invite some of those kids over...")]]

def show_dialogue(conversation):
	
	if DEBUG:
		return
	
	screen = pygame.display.get_surface()
		
	stash = pygame.Surface((1024,768), 0, screen)
	stash.blit(screen, (0,0))
	
	surf = pygame.Surface((1024,768), 0, screen)
	surf.blit(stash, (0,0))
	
	font = resource.get_font('bluehigh', 28)
	
	max_length = 600 - 20 - 150
	line = 0
	
	clock = pygame.time.Clock()
	
	while line < len(dialogues[conversation]):
		
		screen.blit(stash, (0,0))
		
		pygame.draw.rect(screen, pygame.Color('black'), (212, 550, 600, 210))
		pygame.draw.rect(screen, pygame.Color('white'), (212, 550, 600, 210), 1)
		screen.blit(resource.get_image('Portrait' + dialogues[conversation][line][0]), (217, 555))
	
		text = dialogues[conversation][line][1].split(' ')
		y_pos = 555
		while len(text) > 0:
			words = ""
			while len(text) > 0 and font.size(words + " " + text[0])[0] < max_length:
				words = words + " " + text[0]
				text = text[1:]
			screen.blit(font.render(words, True, pygame.Color('white')), (367, y_pos))
			y_pos += font.get_linesize()
		
		surf.blit(screen, (0,0))
	
		waiting = True
		while waiting:
			for event in pygame.event.get():
				if event.type == KEYDOWN or event.type == MOUSEBUTTONDOWN:
					if event.type == MOUSEBUTTONDOWN or event.key not in metakeys:
						waiting = False
				elif event.type == MOUSEMOTION:
					display.get_screen().cursor_moved()
			
			screen.blit(surf, (0,0))
			display.get_screen().mouse_only()
			clock.tick(20)
		
		line += 1
